SystemOrganization addCategory: #'TpFinalSquash-Core'!
SystemOrganization addCategory: #'TpFinalSquash-TestCases'!

Object subclass: #ClubTp
	instanceVariableNames: 'nombre jugadores partidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!ClubTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 21:39'!
conNombre:unNombre
	^ (self new) nombre: unNombre ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:36'!
addPlayer: unNombre withRanking:unNumero  at: unaFecha
	jugadores add: (JugadorTp nuevoJugadorNombre: unNombre  ranking: unNumero   fecha: unaFecha  )! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 22:30'!
asignarRanking: unNumero nombre: unNombre fecha:unaFecha
	|jugador|
	"asigna un ranking al jugador en una fecha, se valida que el jugador exista"
	jugador  := jugadores detect: [:each | each nombre = unNombre].
	
	jugador asignarRanking: unNumero  fecha: unaFecha esAsignado: true
	
! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 15:14'!
buscarRanking: unNombre at: unaFecha
	| jugador rankingSalida|
	
	"pruebas, 1era buscar en la coleccion de esta clase 'club' al jugador, luego pedirle a el jugador sus ranking y filtrar por la fecha
	2da buscar al jugador en la coleccion local luego a un metodo de ese jugador pasarle la fecha para que el busque el ranking y lo retorne, tengo la duda si hacer asi o intentar llegar hasta la clase raking y que ella lo retorne, aun no lo se"
	
	jugador := jugadores detect: [:each | each nombre = unNombre ].
	"1er"
	" jugador misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ]."
	
	"2da"
	^ rankingSalida := jugador buscarRankingfecha: unaFecha .! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:19'!
initialize 
	jugadores := OrderedCollection new! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:21'!
jugador: unaPosicion
	^ jugadores at: unaPosicion ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 20:37'!
nombre
	^ nombre ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 20:37'!
nombre:unNombre
	nombre := unNombre ! !

Object subclass: #PersonaTp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

PersonaTp subclass: #JugadorTp
	instanceVariableNames: 'nombre rankingInicial fechaIngreso misPartidos misRankings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!JugadorTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:10'!
newJugadorNombre: unNombre ranking: unNumero fecha: unaFecha
	^ self new nombre: unNombre; rankinInicial: unNumero ; fechaIngreso: unaFecha 
	! !

!JugadorTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:10'!
nuevoJugadorNombre: unNombre ranking: unNumero fecha: unaFecha
	"1era se crea solo el jugador
	2da se envia un mensje a un metodo que inplementa la creacion del jugador y inicializa la coleccion de 	ranking"
		
	"^ (self new) nombre: unNombre; rankinInicial: unNumero ; fechaIngreso: unaFecha " 
	
	^ (self new) nuevoJugador: unNombre  fecha: unaFecha  ranking: unNumero 
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 22:11'!
asignarRanking: unNumero fecha: unaFecha esAsignado: unaBandera
| rankingSalida |
	"agregar ranking al historico"

	" misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ]. "
	misRankings add: (RankingTp nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera ).! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 20:56'!
buscarRankingfecha: unaFecha
| rankingSalida |
	"Recorro los rankings del jugador y cuando una fecha conincida con el parametro a buscar retorno el ranking"

	"prueba usar detect"
	misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ].
	
	^ rankingSalida! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:07'!
fechaIngreso 
	^ fechaIngreso ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:07'!
fechaIngreso: unaFecha
	fechaIngreso := unaFecha ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:07'!
initialize 
	misPartidos := OrderedCollection new.
	misRankings := OrderedCollection new! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:29'!
misRankings 
	^ misRankings ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:05'!
nombre 
	^ nombre ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:05'!
nombre: unNombre
	nombre := unNombre ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:13'!
nuevoJugador: unNombre fecha: unaFecha ranking: unNumero
	"Aqui se pretende crear un jugador y a la vez cargar en la coleccion de ranking su ranking inicial"
	
	nombre := unNombre. fechaIngreso := unaFecha . rankingInicial := unNumero.
	
	misRankings add: ( RankingTp nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: true) .
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:25'!
rankingInicial 
	^ rankingInicial ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:25'!
rankingInicial: unNumero
	rankingInicial := unNumero ! !

Object subclass: #RankingTp
	instanceVariableNames: 'fecha ranking esAsignado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!RankingTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:35'!
nuevoRankingConFecha: unaFecha ranking: unNumero
	^ (self new) fecha: unaFecha ;ranking: unNumero ! !

!RankingTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:58'!
nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera
	^ (self new) fecha: unaFecha ;ranking: unNumero ; esAsignado: unaBandera ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:00'!
esAsignado
	" indica si el ranking se cargo por una asignacion o como resultado de un partido"
	^ esAsignado ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:13'!
esAsignado: unaBandera
	esAsignado := unaBandera ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:19'!
fecha
	^ fecha! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:25'!
fecha: unafecha
	fecha := unafecha! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:24'!
initialize 
	esAsignado := false! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:19'!
ranking
	^ ranking ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:27'!
ranking: unNumero
	ranking := unNumero ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:23'!
setEsAsignado
	esAsignado := true! !

Object subclass: #SquashSystem
	instanceVariableNames: 'club'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!SquashSystem class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:42'!
newWithName: unNombre
 | club  |  
	"voy a probar 
		1 si retorno desde aqui una instancia de ClubTp, practicamente llamare  a los metodos de ClubTp sin pasar por SquashSystem  
		2 si creo una instancia de SquashSytem, internamente creo el ClubTp y tendre en SquashSystem metodos que seran el puente a ClubTp  "
		
	" ^ ClubTp conNombre: unNombre ^ "
	
	^ self new nameClub: unNombre
	  
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:10'!
addPlayer: unNombre withRanking: unNumero  at: unaFecha
	"Envia el mensaje al club paraa que procese el ingreso de un nuevo jugador"
	"^ (club at: 1) addPlayer: unNombre  withRanking: unNumero  at: unaFecha "
	(club  first) addPlayer:  unNombre  withRanking: unNumero  at: unaFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 22:20'!
assignRanking: unNumero to: unNombre at: unaFecha

	(club  first) asignarRanking: unNumero nombre: unNombre fecha: unaFecha! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:33'!
initialize 
	" Estoy evaluando
		 crear una coleccion y agregar el club, este metodo es parte de la 2da prueba que se comenta en el metodo de clase de SquashSystem "
	club := OrderedCollection new
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:11'!
nameClub
	" ^ ClubTp nombre "
	^ (club first) nombre ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:34'!
nameClub: unNombre
	"este metodo es parte de la 2da prueba que se comenta en el metodo de clase de SquashSystem "
	club add: ((ClubTp new) nombre: unNombre )
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:11'!
namePlayer: unaPosicion
	^ (club first) jugador: unaPosicion! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:13'!
newWithNameee: unNombre
	"Agrega a la coleccion club un nuevo club el cual se crea apartir del envio de un nombre para dicho club"
	club add: (ClubTp conNombre: unNombre )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:39'!
rankingOf: unNombre at: unaFecha
	^ (club  first) buscarRanking: unNombre  at: unaFecha ! !

TestCase subclass: #TestCaseSquashTp
	instanceVariableNames: 'squashSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-TestCases'!

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 22:45'!
initialize 
	" squashSystem := SquashSystem new "! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:48'!
setUp 
	squashSystem := SquashSystem newWithName: 'La Plata Squash Club'.
	
	squashSystem addPlayer: 'Ralph' withRanking: 1400 at: '2013-06-01' asDateAndTime.! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 22:45'!
tearDown 
	" squashSystem := nil "! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:39'!
test01

	self assert: ((squashSystem rankingOf: 'Ralph' at: '2013-06-01' asDateAndTime) closeTo: 1400).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 22:17'!
test03

 	squashSystem assignRanking: 1600 to: 'Ralph' at: '2013-06-04' asDateAndTime.
	
	self assert: ((squashSystem rankingOf: 'Ralph' at: '2013-06-04' asDateAndTime) closeTo: 1600).

! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:50'!
testNombre
"	self assert: (( squashSystem nombre  = 'La Plata Squash Club'))"
"	self should: [ squashSystem nombre   = 'La Plata Squash Club']."
	
"	 self assert: (( (squashSystem jugador: 1) nombre  = 'Ralph'))"
	

"2da forma" 

self should: [ squashSystem nameClub   = 'La Plata Squash Club'].
self assert: (( (squashSystem  namePlayer: 1) nombre  = 'Ralph'))! !
